
#ifndef MAP_H
#define MAP_H

#include <vector>
#include "mbed.h"

/** Map Class
@author Dobri Tsvetkov, University of Leeds
@brief C++ class define a map for the track
@date May 2019
*/ 
class Map {
    
  public:
    /**
    @brief init method
    @param None 
    @details initialises some of the variables
    */
    void init();
    
    // accessors
    /**
    @brief Player Curvature accessor
    @param None 
    @details returns float _player_curvature
    */
    float get_player_curvature();
    /**
    @brief Tiemed curvature accessor
    @param None 
    @details returns float _timed_curvature
    */
    float get_timed_curvature();
    
    // mutators
    /**
    @brief Player Curvature mutator
    @param float _player_curvature 
    @details 
    */
    void set_player_curvature(float _player_curvature);
    /**
    @brief Timed curvature mutator
    @param float _timed_curvature 
    @details 
    */
    void set_timed_curvature(float _timed_curvature);
  
  private:
    float _player_curvature; /**<float variable to measure how far is the player from desired curvature */
    float _timed_curvature; /**<float curvature of the track with speed taken into account */
};

#endif